﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace szinkep
{
    class Pont
    {
        public int R { get; set; }
        public int G { get; set; }
        public int B { get; set; }
        public string RGBh ()
        {
            return R.ToString("X2") + G.ToString("X2") + B.ToString("X2");
        }

        public Pont(string[] adat)
        {
            R = int.Parse(adat[0]);
            G = int.Parse(adat[1]);
            B = int.Parse(adat[2]);
        }
    }
    class Program
    {
        static void Main(string[] args)
        {
            #region beolvasás
            StreamReader sr = new StreamReader("kep.txt");
            Pont[] kep = new Pont[2500];
            for (int i = 0; i < 2500; i++)
            {
                kep[i] = new Pont(sr.ReadLine().Split(' '));
            }
            sr.Close();
            #endregion
            #region színkeresés
            Console.WriteLine("2. feladat");
            string[] szin = new string[3];
            Console.Write("Adja meg egy pont színösszetevőit!\n\tVörös:\t");
            szin[0] = Console.ReadLine();
            Console.Write("\tZöld:\t");
            szin[1] = Console.ReadLine();
            Console.Write("\tKék:\t");
            szin[2] = Console.ReadLine();
            Pont pont = new Pont(szin);
            int t = 0;
            while (t<2500 && kep[t].RGBh() != pont.RGBh())
            {
                t++;
            }
            Console.WriteLine("A megadott szín {0} a képen.", t<2500 ? "*megtalálható*" : "*nem található meg*");
            #endregion
            #region előfordulások száma
            pont = kep[(35 - 1) * 50 + (8 - 1)];
            int dbs = 0;
            int dbo = 0;
            for (int i = 0; i < 50; i++)
            {
                if (kep[(35-1)*50 + i].RGBh() == pont.RGBh())
                {
                    dbs++;
                }
                if (kep[i*50 + (8-1)].RGBh() == pont.RGBh())
                {
                    dbo++;
                }
            }
            Console.WriteLine("3. feladat");
            Console.WriteLine("Sorban: {0} \tOszlopban: {1} \t(Összesen: {2})", dbs, dbo, dbs + dbo - 1);
            #endregion
            #region legtöbbször
            int[] dbc = new int[3];
            for (int i = 0; i < 3; i++)
            {
                dbc[i] = 0;
            }
            for (int i = 0; i < 2500; i++)
            {
                if (kep[i].RGBh() == "FF0000")
                {
                    dbc[0]++;
                }
                else if (kep[i].RGBh() == "00FF00")
                {
                    dbc[1]++;
                }
                else if (kep[i].RGBh() == "0000FF")
                {
                    dbc[2]++;
                }
            }
            Console.WriteLine("4. feladat");
            string color = "";
            if (dbc[0]> dbc[1])
            {
                if (dbc[0]>dbc[2])
                {
                    color = "vörös";
                }
                else
                {
                    color = "kék";
                }
            }
            else if(dbc[1]>dbc[2])
            {
                color = "zöld";
            }
            else
            {
                color = "kék";
            }
            Console.WriteLine("A legtöbbször előforduló szín a {0}", color);
            #endregion
            #region fekete keret
            //a négy oldal egyszerre, néhány pixelt duplán vesz
            //for (int i = 0; i < 50; i++)
            //{
            //    for (int j = 0; j < 3; j++)
            //    {
            //        kep[j * 50 + i].R = 0;
            //        kep[j * 50 + i].G = 0;
            //        kep[j * 50 + i].B = 0;
            //        kep[i * 50 + j].R = 0;
            //        kep[i * 50 + j].G = 0;
            //        kep[i * 50 + j].B = 0;
            //        kep[i * 50 + (49 - j)].R = 0;
            //        kep[i * 50 + (49 - j)].G = 0;
            //        kep[i * 50 + (49 - j)].B = 0;
            //        kep[(49 - j) * 50 + i].R = 0;
            //        kep[(49 - j) * 50 + i].G = 0;
            //        kep[(49 - j) * 50 + i].B = 0;
                    
            //    }
            //}

            //egy kicsit másképp, a sorfolytonos tárolást kihasználva
            for (int i = 0; i < 150; i++)
            {
                kep[i].R = 0;
                kep[i].G = 0;
                kep[i].B = 0;
                kep[2499 - i].R = 0;
                kep[2499 - i].G = 0;
                kep[2499 - i].B = 0;
            }
            for (int i = 2; i < 47; i++)
            {
                for (int j = 47; j < 53; j++)
                {
                    kep[i * 50 + j].R = 0;
                    kep[i * 50 + j].G = 0;
                    kep[i * 50 + j].B = 0;
                }
            }
            #endregion
            #region fájlba írás
            StreamWriter sw = new StreamWriter("keretes.txt");
            for (int i = 0; i < 2500; i++)
            {
                sw.WriteLine("{0} {1} {2}", kep[i].R, kep[i].G, kep[i].B);
            }
            sw.Close();
            #endregion

            #region sárga háromszög
            int ott = 0;
            while (kep[ott].RGBh() != "FFFF00")
            {
                ott++;
            }
            int itt = ott;
            ott = 2499;
            while (kep[ott].RGBh() != "FFFF00")
            {
                ott--;
            }

            int kezdSor = itt / 50 + 1;
            int kezdOszl = itt % 50 + 1;
            Console.WriteLine("Kezd: {0}, {1}", kezdSor, kezdOszl);
            int végSor = ott / 50 + 1;
            int végOszl = ott % 50 + 1;
            Console.WriteLine("Vége: {0}, {1}", végSor, végOszl);
            int pontSzám = (végSor - kezdSor + 1) * (végOszl - kezdOszl + 1);
            Console.WriteLine("Képpontok száma: {0}", pontSzám);
            #endregion

            Console.ReadLine();
        }
    }
}
